function Create(self)	
	self.GunTimer = {Timer(), Timer()}
	self.TargetTimer = {Timer(), Timer()}
	self.ReloadTimer = {Timer(), Timer()}
	self.Target = {nil, nil}
	self.tarAng = {0, 0}
	self.gunAng = {math.pi + 0.1, 2 * math.pi - 0.1}
	self.limitHi = {3.85, 6.283185}
	self.limitLo = {3.141592, 5.34}
	self.maxAmmo = 18
	self.ammo = {self.maxAmmo, self.maxAmmo}
	self.reloadTime = 2000
	self.lead = 3									-- 4 Aim in front of a moving target
	self.left = true
	self.Barrel = "DA Barrel"
	self.Boxes = {}
	
	local HalfSize = Vector(290, 190)
	local Pos = Vector(-360, 150)	-- the Dummy dropship is ~70*2 units wide (280+70=350)
	table.insert(self.Boxes, Box(Vector(self.Pos.X + Pos.X - HalfSize.X , self.Pos.Y + Pos.Y - HalfSize.Y), Vector(self.Pos.X + Pos.X + HalfSize.X, self.Pos.Y + Pos.Y + HalfSize.Y)))
	Pos:SetXY(360, 150)
	table.insert(self.Boxes, Box(Vector(self.Pos.X + Pos.X - HalfSize.X , self.Pos.Y + Pos.Y - HalfSize.Y), Vector(self.Pos.X + Pos.X + HalfSize.X, self.Pos.Y + Pos.Y + HalfSize.Y)))
end

function Offset(Origin, ang, dist)
	local Tmp = Vector(0, 0)
	Tmp:SetMagnitude(dist)
	Tmp:RadRotate(ang)
	Tmp = Tmp + Origin
	return Tmp
end

function Destroy(self)
	self.Target[1] = nil
	self.Target[2] = nil
end

function Update(self)
	local i = 1
	if not self.left then
		i = 2
	end
	
	self.left = not self.left

	if self.ammo[i] < 1 and self.ReloadTimer[i]:IsPastSimMS(self.reloadTime) then
		self.ammo[i] = self.maxAmmo
	end
	
	if self.Target[i] ~= nil then
		if self.TargetTimer[i]:IsPastSimMS(100) then -- Validate target, and recalculate angle
			self.TargetTimer[i]:Reset()
			UpdateBoxes(self)
			if MovableMan:IsActor(self.Target[i]) and self.Boxes[i]:WithinBox(self.Target[i].Pos) then
				--local GunPos = Offset(Offset(self.Pos, self.RotAngle + 1.570796, 14), self.RotAngle + (2-i)*3.141592, 52)
				local GunPos = Offset(self.Pos, self.RotAngle + (2-i)*3.141592, 52)
				self.tarAng[i] = ((self.Target[i].Pos + (self.Target[i].Vel * self.lead)) - GunPos).AbsRadAngle
				if self.tarAng[i] < 0 then
					self.tarAng[i] = self.tarAng[i] + 6.283185
				end
			else
				self.Target[i] = nil
			end
		end
	elseif self.ammo[i] > 0 and self.TargetTimer[i]:IsPastSimMS(250) then
		UpdateBoxes(self)
		if self.Target[1] == nil and self.Target[2] == nil then
			self.TargetTimer[1]:Reset()
			self.TargetTimer[2]:Reset()
			hit = false
			start = 1
			stop = #self.Boxes
			for Act in MovableMan.Actors do
				if Act.Team ~= self.Team then
					for k = start, stop do
						if self.Boxes[k]:WithinBox(Act.Pos) then
							self.Target[k] = Act
							hit = true
							break
						end
					end
					
					if hit then
						if self.Target[1] ~= nil and self.Target[2] ~= nil then
							break
						elseif self.Target[1] ~= nil then
							start = #self.Boxes
							hit = false
						elseif self.Target[2] ~= nil then
							stop = 1
							hit = false
						end
					end
				end
			end
		else
			self.TargetTimer[i]:Reset()
			for Act in MovableMan.Actors do
				if Act.Team ~= self.Team then
					if self.Boxes[i]:WithinBox(Act.Pos) then
						self.Target[i] = Act
						break
					end
				end
			end
		end
		
		if self.Target[i] ~= nil and MovableMan:IsActor(self.Target[i]) then
			self.tarAng[i] = ((self.Target[i].Pos + (self.Target[i].Vel * self.lead)) - self.Pos).AbsRadAngle			
			if self.tarAng[i] < 0 then
				self.tarAng[i] = self.tarAng[i] + 6.283185
			end
		end
	end
	
	-- Track target
	if self.Target[i] ~= nil and MovableMan:IsActor(self.Target[i]) then		
		local rotDiff = self.tarAng[i] - self.gunAng[i]
		local tmp = self.gunAng[i] - self.tarAng[i]
		if math.abs(tmp) < math.abs(rotDiff) then
			rotDiff = tmp
		end
		
		if math.abs(rotDiff) > 0.01 then
			local rot = 0
			if rotDiff > 0 then
				rot = math.min(0.06, rotDiff)
			else
				rot = math.max(-0.06, rotDiff)
			end
			
			self.gunAng[i] = math.min(math.max(self.gunAng[i] + rot, self.RotAngle + self.limitLo[i]), self.RotAngle + self.limitHi[i])
		end
		
		-- Fire Tid
		if math.abs(rotDiff) < 0.2 and self.ammo[i] > 0 and self.GunTimer[i]:IsPastSimMS(250) then
			self.GunTimer[i]:Reset()
			
			local bulletType = "DA MG"
			if self.ammo[i] % 4 == 0 then
				bulletType = "DA MG Tracer"
			end
			
			local Emitter = CreateAEmitter(bulletType)
			local Casing = CreateMOSParticle("DA MG Casing")
			Ofs = Offset(self.Pos, self.RotAngle + 1.570796, 14)	-- up x units
			Ofs = Offset(Ofs, self.RotAngle + (2-i)*3.141592, 52)	-- right/left x units
			
			Emitter.Pos = Offset(Ofs, self.gunAng[i], 38)   -- 25
			Emitter.Vel = self.Vel
			Emitter.RotAngle = self.gunAng[i]
			MovableMan:AddParticle(Emitter)
			
			Casing.Pos = Offset(Ofs, self.gunAng[i] + 1.5 - i, 15)	-- x units along the barrel
			Casing.RotAngle = self.gunAng[i]
			Casing.AngularVel = 2 + math.random() * 10
			Casing.Vel = self.Vel * (1.2 - math.random()*0.4)
			Casing.Vel.X = self.Vel.X + (i - 1.5) * 5
			MovableMan:AddParticle(Casing)
			
			self.ammo[i] = self.ammo[i] - 1
			if self.ammo[i] == 0 then
				self.ReloadTimer[i]:Reset()
			end
		end
	else 	-- Reset barrel
		local rotDiff = (self.RotAngle + (self.limitLo[i] + self.limitHi[i])/2) - self.gunAng[i]
		if math.abs(rotDiff) > 0.1 then
			if rotDiff > 0 then
				rotDiff = math.min(0.03, rotDiff)
			else
				rotDiff = math.max(-0.03, rotDiff)
			end
			
			self.gunAng[i] = math.min(math.max(self.gunAng[i] + rotDiff, self.RotAngle + self.limitLo[i]), self.RotAngle + self.limitHi[i])
		end
	end
	
	-- Draw barrels
	for j = 1, 2 do
		Barrel = CreateMOSRotating(self.Barrel)
		Ofs = Offset(self.Pos, self.RotAngle + 1.570796, 14)
		Barrel.Pos = Offset(Ofs, self.RotAngle + (2-j)*3.141592, 52)
		Barrel.RotAngle = self.gunAng[j]
		MovableMan:AddParticle(Barrel)
	end
end

function UpdateBoxes(self)
	local HalfSize = Vector(290, 190)
	local Pos = Vector(-360, 150)	-- the Dummy dropship is ~70*2 units wide (290+70=360)
	self.Boxes[1].Corner = Vector(self.Pos.X + Pos.X - HalfSize.X, self.Pos.Y + Pos.Y - HalfSize.Y)
	
	Pos:SetXY(360, 150)
	self.Boxes[2].Corner = Vector(self.Pos.X + Pos.X - HalfSize.X, self.Pos.Y + Pos.Y - HalfSize.Y)
end